#define _GNU_SOURCE
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <errno.h>

#include "uhumenu.h"

char *plugin_name = "KDE";

static void write_item (FILE *f, const struct item *item)
{
	int first = 1;
	struct section *s = item->sections;
	struct key *k;
	struct lang *l;
	while (s != NULL) {
		if (!first) fprintf(f, "\n");
		first = 0;
		fprintf(f, "[%s]\n", s->name);
		k = s->keys;
		while (k != NULL) {
			l = k->langs;
			while (l != NULL) {
				if (l->language->name[0] != '\0') {
					fprintf(f, "%s[%s]=%s\n", k->name, l->language->name, l->value);
				} else {
					fprintf(f, "%s=%s\n", k->name, l->value);
				}
				l = l->next;
			}
			k = k->next;
		}
		s = s->next;
	}
}

static void dump (const struct menu *menu, const char *path)
{
	int i, l;
	FILE *f;
	char buf[PATH_MAX];

	for (i = 0; i < menu->nr; i++) {
		sprintf(buf, "%s%s", path, menu->items[i].file_name);
		if (!menu->items[i].issubmenu) {
			l = strlen(buf);
			if (l < 8 || strcmp(buf + l - 8, ".desktop")) strcpy(buf + l, ".desktop");
		} else {
			mkdir(buf, 0777);
			sprintf(buf, "%s%s/.directory", path, menu->items[i].file_name);
		}
		f = fopen(buf, "w");
		write_item(f, &menu->items[i]);
		fclose(f);
		if (menu->items[i].issubmenu) {
			dump(menu->items[i].submenu, path);
		}
	}
}

int write_menu (const struct menu *menu, const char *path)
{
	empty_dir(path);
	dump(menu, path);
	return 0;
}

